// Jogometria
// Autoria: Bruno Luvizotto
// Inspiracao: theeyeballinggame http://woodgears.ca/eyeball/
// Criado para a disciplina Fundamentos da Computacao II
// Prof. Romero Tori
// design FAUUSP

int fase; //determina qual tela aparecera
PImage telainicial;
PImage telafinal;
PImage menu; // contem a imagem de fundo do menu
PImage jogar;
PImage voltar;
PImage avancar; // contem a img do botao avancar desativado
PImage avancarativado; // contem a img do botao avancar ativado
// contem as imagens com as instrucoes de cada pagina, na ordem de aparicao das fases
PImage titulo1;
PImage titulo2;
PImage titulo3;
PImage titulo4;
PFont centurygothic; // carrega a fonte que escreve os pontos do jogador
int ellipsex; //coordenada x do centro da ellipse
int ellipsey; //coordenada y do centro do ellipse
int tamellipse; //determina o diametro da ellipse
int menux;//comprimento do menu
int menuy;//altura do menu
int linex; // armazena mouseX
int liney; // armazena mouseY
int contorno; //regula o stroke do circulo
float dellipsecursor; //contem a distancia entre o centro da
//ellipse e o local em que o mouse clica
float dellipsecursor2;
float dellipsecursor3;
int iniciox; // inicio x da primeira reta do ex. das paralelas
int inicioy; // inicio y da primeira reta das paralelas
int finalx; // final x da primeira r. das paralelas
int finaly; // final y da primeira reta das paralelas
int outraretax; // inicio da outra reta das paralelas
int outraretay; // inicio da outra reta das paralelas
int tamreta; // tamanho das retas paralelas
int dreta; //contem a distancia entre as retas
float dretacertaretax; // armazena a distancia entre a reta paralela e a reta criada pelo jogador
float dretacertaretax2;
float dretacertaretax3;
int inicioparalelox; // para o paralelogramo
int inicioparaleloy; // para o exercicio do paralelogramo
int finalVERTx;
int finalVERTy;
int finalHORx;
int tamVERT;
int tamHOR;
float distaopontocerto;
float distaopontocerto2;
float distaopontocerto3;
int retasinx;
int retasiny;
int retaumfinx;
int retasfiny;
int retadoisfinx;
float tamretas;
float dateespelhado;
float dateespelhado2;
float dateespelhado3;


void setup(){
  size(900,642);
  background(255);
  smooth();
  frameRate(60);
  menux=900;
  menuy=142;
  menu=loadImage("layout.jpg");
  avancar=loadImage("botaoavancar.jpg");
  avancarativado=loadImage("botaoavancar2.jpg");
  telainicial=loadImage("telainicial.jpg");
  telafinal=loadImage("telafinal.jpg");
  voltar=loadImage("botaovoltar.jpg");
  jogar=loadImage("botaojogar.jpg");
  titulo1=loadImage("titulocirc.jpg");
  titulo2=loadImage("tituloretas.jpg");
  titulo3=loadImage("tituloparalelogramo.jpg");
  titulo4=loadImage("tituloespelhamento.jpg");
  centurygothic=loadFont("CenturyGothic-Bold-48.vlw");
  textFont(centurygothic,12);
  contorno=2;
  tamellipse=(int)random(150,400);
  ellipsex=(int)random(tamellipse/2,850-tamellipse/2);
  ellipsey=(int)random(menuy+20+tamellipse/2,632-tamellipse/2);
  iniciox=(int)random(150,750);
  inicioy=(int)random(menuy+20,300);
  finalx=(int)random(150,750);
  tamreta=(int)random(100,242);
  finaly=inicioy+tamreta;
  dreta=75;
  outraretax=iniciox+dreta;
  outraretay=inicioy;
  tamVERT=(int)random(80,160);
  tamHOR=(int)random(150,200);
  inicioparalelox=(int)random(150,750-tamHOR);
  inicioparaleloy=(int)random(menuy+20,400);
  finalVERTx=(int)random(150,750-tamHOR);
  finalVERTy=inicioy+tamVERT;
  finalHORx=iniciox+tamHOR;
  retasinx=(int)random(250,750);
  retasiny=(int)random(menuy+170,400);
  retaumfinx=retasinx-(int)random(100,200);
  retasfiny=retasiny+150;
  retadoisfinx=retasinx+150;
  fase=0;
}

void draw(){
  if (fase == 0){
    image(telainicial,0,0,900,642);
    if(mouseX>803&&mouseY>592){
      image(jogar,803,592,97,45);
      if(mousePressed){
        fase=1; 
      }
    } 
  }
  if (fase == 1){ // fase da circunferencia
    background(255);
    stroke(0);
    noFill();
    image(menu,0,0,900,142);
    image(titulo1,12,115,314,27);
    noStroke();
    fill(0);
    ellipse(ellipsex,ellipsey,tamellipse,tamellipse);
    fill(255);
    ellipse(ellipsex,ellipsey,tamellipse-contorno,tamellipse-contorno);// cria ellipse em qualquer lugar, de tamanho randomico
    if(mouseY>menuy&&mouseY<600){ // impede que o cursor fique no menu
      //desenha cursor
      stroke(0);
      line(mouseX-10,mouseY,mouseX+10,mouseY);
      line(mouseX,mouseY-10,mouseX,mouseY+10);
      if(mousePressed){
        stroke(0);
        noFill();
        //linhas em cruz com centro no ponto em que o mouse esta
        line(mouseX-10,mouseY,mouseX+10,mouseY);
        line(mouseX,mouseY-10,mouseX,mouseY+10);
        //guarda os valores do centro da cruz
        linex=mouseX;
        liney=mouseY;
        dellipsecursor = sqrt(pow((linex - ellipsex),2) + pow((liney - ellipsey),2));
        println(int(dellipsecursor));
        fase=2;
      }
    }
  }
  if(fase == 2){ //muda para a etapa em que a tela para e o jogador confere seus pontos e pede para avancar
    //desenha a cruz do centro do circulo em verde e a linha
    //que liga o centro do circulo ao centro da cruz do cursor
    noStroke();
    fill(255);
    rect(12,115,315,28);
    stroke(68,57,117);
    line(ellipsex,ellipsey,linex,liney);
    line(ellipsex-10,ellipsey,ellipsex+10,ellipsey);
    line(ellipsex,ellipsey-10,ellipsex,ellipsey+10);
    fill(68,57,117);
    text((int)dellipsecursor,540,85);
    noStroke();
    image(avancar,750,600,150,36);
    if(mouseX>750&&mouseY>600){ //Acende o botao caso o mouse passe ali
      image(avancarativado,750,600,150,36);
      if(mousePressed){
        fase=3;
        delay(100);
      }
    }
    else{
      image(avancar,750,600,150,36);
    }
  }
  if(fase == 3){ // fase das retas paralelas
    fill(255);
    noStroke();
    image(titulo2,12,115,314,27);
    rect(0,menuy+1,menux,500); // apaga somente a tela de jogo
    stroke(0);
    line(iniciox,inicioy,finalx,finaly);
    if (mouseY>menuy&&mouseY<600){
      line(outraretax,outraretay,mouseX,mouseY);
      if (mousePressed){
        stroke(68,57,117);
        linex=mouseX; //armazena o valor de mouseX
        line(outraretax,outraretay,finalx+dreta,finaly);
        fase=4;
      }
    }
  }
  if(fase == 4){
    noStroke();
    fill(255);
    rect(12,115,315,28);
    stroke(0);
    dretacertaretax=sqrt(pow((finalx - linex),2) + pow((finaly - finaly),2));
    println(int(dretacertaretax-dreta));
    fill(68,57,117);
    text((int)dretacertaretax,540,102);
    noStroke();
    noFill();
    image(avancar,750,600,150,36);
    if(mouseX>750&&mouseY>600){ //Acende o botao caso o mouse passe ali
      image(avancarativado,750,600,150,36);
      if(mousePressed){
        fase=5;
        delay(100);
      }
    }
    else{
      image(avancar,750,600,150,36);
    }
  }
  if(fase == 5){ // fase do paralelogramo
    fill(255);
    noStroke();
    rect(0,menuy+1,menux,500); // apaga a tela de jogo
    image(titulo3,12,115,314,27);
    stroke(0);
    line(iniciox,inicioy,finalHORx,inicioy);
    line(iniciox,inicioy,finalVERTx,finalVERTy);
    if(mouseY>menuy&&mouseY<600){
      line(finalVERTx,finalVERTy,mouseX,mouseY);
      line(finalHORx,inicioy,mouseX,mouseY);
      if(mousePressed){
        stroke(68,57,117);
        linex=mouseX; // TESTANDO USAR A MESMA VARIAVEL PARA ARMAZENAR O MOUSEX
        line(finalVERTx,finalVERTy,finalVERTx+tamHOR,finalVERTy);
        line(finalHORx,inicioy,finalVERTx+tamHOR,finalVERTy);
        fase=6;
      }
    }
  }
  if(fase == 6){
    noStroke();
    fill(255);
    rect(12,115,315,28);
    image(avancar,750,600,150,36); // botao avancar
    // calcura e imprime a distancia a reta certa
    distaopontocerto=sqrt(pow((finalVERTx+tamHOR - linex),2) + pow((finalVERTy - finalVERTy),2));
    println(int(distaopontocerto));
    fill(68,57,117);
    text((int)distaopontocerto,540,120);
    if(mouseX>750&&mouseY>600){ //Acende o botao caso o mouse passe ali
      image(avancarativado,750,600,150,36);
      if(mousePressed){
        fase=7;
        delay(100);
      }
    }
    else{
      image(avancar,750,600,150,36);
    }
  }
  if(fase == 7){ // fase do espelhamento
    fill(255);
    noStroke();
    rect(0,menuy+1,menux,500); // apaga a tela de jogo
    image(titulo4,12,115,314,27);
    stroke(0);
    line(retasinx,retasiny,retaumfinx,retasfiny);
    stroke(0,150,150);
    line(retaumfinx-20,retasiny,retasinx+(retasinx-retaumfinx),retasiny);
    if (mouseY>menuy&&mouseY<600){
      stroke(0);
      line(retasinx,retasiny,mouseX,mouseY);
      if (mousePressed){
        stroke(68,57,117);
        int tenta90x=mouseX; //armazena o valor de mouseX
        int tenta90y=mouseY;
        line(retasinx,retasiny,retaumfinx,retasfiny-retasiny);
        dateespelhado=sqrt(pow((tenta90x - retaumfinx),2) + pow((tenta90y - (retasfiny-retasiny)),2));
        println(int(dateespelhado));
        fase=8;
      } 
    }
  }
  if(fase == 8){
    noStroke();
    fill(255);
    rect(12,115,315,28);
    image(avancar,750,600,150,36);
    fill(68,57,117);
    text((int)dateespelhado,540,138);
    if(mouseX>750&&mouseY>600){ //Acende o botao caso o mouse passe ali
      image(avancarativado,750,600,150,36);
      if(mousePressed){
        fase=9;
        delay(100);
      }
    }
    else{
      image(avancar,750,600,150,36);
    }
  }
  if (fase == 9){ // fase da circunferencia
    fill(255);
    noStroke();
    rect(0,menuy+1,menux,500); // apaga a tela de jogo
    image(titulo1,12,115,314,27);
    fill(0);
    ellipse(ellipsex,ellipsey,tamellipse,tamellipse);
    fill(255);
    ellipse(ellipsex,ellipsey,tamellipse-contorno,tamellipse-contorno);// cria ellipse em qualquer lugar, de tamanho randomico
    if(mouseY>menuy&&mouseY<600){ // impede que o cursor fique no menu
      //desenha cursor
      stroke(0);
      line(mouseX-10,mouseY,mouseX+10,mouseY);
      line(mouseX,mouseY-10,mouseX,mouseY+10);
      if(mousePressed){
        stroke(0);
        noFill();
        //linhas em cruz com centro no ponto em que o mouse esta
        line(mouseX-10,mouseY,mouseX+10,mouseY);
        line(mouseX,mouseY-10,mouseX,mouseY+10);
        //guarda os valores do centro da cruz
        linex=mouseX;
        liney=mouseY;
        dellipsecursor2 = sqrt(pow((linex - ellipsex),2) + pow((liney - ellipsey),2));
        println(int(dellipsecursor2));
        fase=10;
      }
    }
  }
  if(fase == 10){ //muda para a etapa em que a tela para e o jogador confere seus pontos e pede para avancar
    //desenha a cruz do centro do circulo em verde e a linha
    //que liga o centro do circulo ao centro da cruz do cursor
    noStroke();
    fill(255);
    rect(12,115,315,28);
    stroke(68,57,117);
    line(ellipsex,ellipsey,linex,liney);
    line(ellipsex-10,ellipsey,ellipsex+10,ellipsey);
    line(ellipsex,ellipsey-10,ellipsex,ellipsey+10);
    fill(68,57,117);
    text((int)dellipsecursor2,660,85);
    noStroke();
    image(avancar,750,600,150,36); //botao avancar
    if(mouseX>750&&mouseY>600){ //Acende o botao caso o mouse passe ali
      image(avancarativado,750,600,150,36);
      if(mousePressed){
        fase=11;
        delay(100);
      }
    }
    else{
      image(avancar,750,600,150,36);
    }
  }
  if(fase == 11){ // fase das retas paralelas
    fill(255);
    noStroke();
    rect(0,menuy+1,menux,500); // apaga somente a tela de jogo
    image(titulo2,12,115,314,27);
    stroke(0);
    line(iniciox,inicioy,finalx,finaly);
    if (mouseY>menuy&&mouseY<600){
      line(outraretax,outraretay,mouseX,mouseY);
      if (mousePressed){
        stroke(68,57,117);
        linex=mouseX; //armazena o valor de mouseX
        line(outraretax,outraretay,finalx+dreta,finaly);
        fase=12;
      }
    }
  }
  if(fase == 12){
    noStroke();
    fill(255);
    rect(12,115,315,28);
    image(avancar,750,600,150,36);
    dretacertaretax2=sqrt(pow((finalx - linex),2) + pow((finaly - finaly),2));
    println(int(dretacertaretax2-dreta));
    fill(68,57,117);
    text((int)dretacertaretax2,660,102);
    if(mouseX>750&&mouseY>600){ //Acende o botao caso o mouse passe ali
      image(avancarativado,750,600,150,36);
      if(mousePressed){
        fase=13;
        delay(100);
      }
    }
    else{
      image(avancar,750,600,150,36);
    }
  }
  if(fase == 13){ // fase do paralelogramo
    fill(255);
    noStroke();
    rect(0,menuy+1,menux,500); // apaga a tela de jogo
    image(titulo3,12,115,314,27);
    stroke(0);
    line(iniciox,inicioy,finalHORx,inicioy);
    line(iniciox,inicioy,finalVERTx,finalVERTy);
    if(mouseY>menuy&&mouseY<600){
      line(finalVERTx,finalVERTy,mouseX,mouseY);
      line(finalHORx,inicioy,mouseX,mouseY);
      if(mousePressed){
        stroke(68,57,117);
        linex=mouseX; // TESTANDO USAR A MESMA VARIAVEL PARA ARMAZENAR O MOUSEX
        line(finalVERTx,finalVERTy,finalVERTx+tamHOR,finalVERTy);
        line(finalHORx,inicioy,finalVERTx+tamHOR,finalVERTy);
        fase=14;
      }
    }
  }
  if(fase == 14){
    noStroke();
    fill(255);
    rect(12,115,315,28);
    image(avancar,750,600,150,36); // botao avancar
    // calcura e imprime a distancia a reta certa
    distaopontocerto2=sqrt(pow((finalVERTx+tamHOR - linex),2) + pow((finalVERTy - finalVERTy),2));
    println(int(distaopontocerto2));
    fill(68,57,117);
    text((int)distaopontocerto2,660,120);
    if(mouseX>750&&mouseY>600){ //Acende o botao caso o mouse passe ali
      image(avancarativado,750,600,150,36);
      if(mousePressed){
        fase=15;
        delay(100);
      }
    }
    else{
      image(avancar,750,600,150,36);
    }
  }
  if(fase == 15){ // fase do espelhamento
    fill(255);
    noStroke();
    rect(0,menuy+1,menux,500); // apaga a tela de jogo
    image(titulo4,12,115,314,27);
    stroke(0);
    line(retasinx,retasiny,retaumfinx,retasfiny);
    stroke(0,150,150);
    line(retaumfinx-20,retasiny,retasinx+(retasinx-retaumfinx),retasiny);
    if (mouseY>menuy&&mouseY<600){
      stroke(0);
      line(retasinx,retasiny,mouseX,mouseY);
      if (mousePressed){
        stroke(68,57,117);
        int tenta90x=mouseX; //armazena o valor de mouseX
        int tenta90y=mouseY;
        line(retasinx,retasiny,retaumfinx,retasfiny-retasiny);
        dateespelhado2=sqrt(pow((tenta90x - retaumfinx),2) + pow((tenta90y - (retasfiny-retasiny)),2));
        println(int(dateespelhado2));
        fase=16;
      } 
    }
  }
  if(fase == 16){
    noStroke();
    fill(255);
    rect(12,115,315,28);
    image(avancar,750,600,150,36);
    fill(68,57,117);
    text((int)dateespelhado2,660,138);
    if(mouseX>750&&mouseY>600){ //Acende o botao caso o mouse passe ali
      image(avancarativado,750,600,150,36);
      if(mousePressed){
        fase=17;
        delay(100);
      }
    }
    else{
      image(avancar,750,600,150,36);
    }
  }
  if (fase == 17){ // fase da circunferencia
    fill(255);
    noStroke();
    rect(0,menuy+1,menux,500); // apaga a tela de jogo
    image(titulo1,12,115,314,27);
    fill(0);
    ellipse(ellipsex,ellipsey,tamellipse,tamellipse);
    fill(255);
    ellipse(ellipsex,ellipsey,tamellipse-contorno,tamellipse-contorno);// cria ellipse em qualquer lugar, de tamanho randomico
    if(mouseY>menuy&&mouseY<600){ // impede que o cursor fique no menu
      //desenha cursor
      stroke(0);
      line(mouseX-10,mouseY,mouseX+10,mouseY);
      line(mouseX,mouseY-10,mouseX,mouseY+10);
      if(mousePressed){
        stroke(0);
        noFill();
        //linhas em cruz com centro no ponto em que o mouse esta
        line(mouseX-10,mouseY,mouseX+10,mouseY);
        line(mouseX,mouseY-10,mouseX,mouseY+10);
        //guarda os valores do centro da cruz
        linex=mouseX;
        liney=mouseY;
        dellipsecursor3 = sqrt(pow((linex - ellipsex),2) + pow((liney - ellipsey),2));
        println(int(dellipsecursor3));
        fase=18;
      }
    }
  }
  if(fase == 18){ //muda para a etapa em que a tela para e o jogador confere seus pontos e pede para avancar
    //desenha a cruz do centro do circulo em verde e a linha
    //que liga o centro do circulo ao centro da cruz do cursor
    noStroke();
    fill(255);
    rect(12,115,315,28);
    stroke(68,57,117);
    line(ellipsex,ellipsey,linex,liney);
    line(ellipsex-10,ellipsey,ellipsex+10,ellipsey);
    line(ellipsex,ellipsey-10,ellipsex,ellipsey+10);
    fill(68,57,117);
    text((int)dellipsecursor3,780,85);
    noStroke();
    image(avancar,750,600,150,36); //botao avancar
    if(mouseX>750&&mouseY>600){ //Acende o botao caso o mouse passe ali
      image(avancarativado,750,600,150,36);
      if(mousePressed){
        fase=19;
        delay(100);
      }
    }
    else{
      image(avancar,750,600,150,36);
    }
  }
  if(fase == 19){ // fase das retas paralelas
    fill(255);
    noStroke();
    rect(0,menuy+1,menux,500); // apaga somente a tela de jogo
    image(titulo2,12,115,314,27);
    stroke(0);
    line(iniciox,inicioy,finalx,finaly);
    if (mouseY>menuy&&mouseY<600){
      line(outraretax,outraretay,mouseX,mouseY);
      if (mousePressed){
        stroke(68,57,117);
        linex=mouseX; //armazena o valor de mouseX
        line(outraretax,outraretay,finalx+dreta,finaly);
        fase=20;
      }
    }
  }
  if(fase == 20){
    noStroke();
    fill(255);
    rect(12,115,315,28);
    image(avancar,750,600,150,36);
    dretacertaretax3=sqrt(pow((finalx - linex),2) + pow((finaly - finaly),2));
    println(int(dretacertaretax3-dreta));
    fill(68,57,117);
    text((int)dretacertaretax3,780,102);
    if(mouseX>750&&mouseY>600){ //Acende o botao caso o mouse passe ali
      image(avancarativado,750,600,150,36);
      if(mousePressed){
        fase=21;
        delay(100);
      }
    }
    else{
      image(avancar,750,600,150,36);
    }
  }
  if(fase == 21){ // fase do paralelogramo
    fill(255);
    noStroke();
    rect(0,menuy+1,menux,500); // apaga a tela de jogo
    image(titulo3,12,115,314,27);
    stroke(0);
    line(iniciox,inicioy,finalHORx,inicioy);
    line(iniciox,inicioy,finalVERTx,finalVERTy);
    if(mouseY>menuy&&mouseY<600){
      line(finalVERTx,finalVERTy,mouseX,mouseY);
      line(finalHORx,inicioy,mouseX,mouseY);
      if(mousePressed){
        stroke(68,57,117);
        linex=mouseX; // TESTANDO USAR A MESMA VARIAVEL PARA ARMAZENAR O MOUSEX
        line(finalVERTx,finalVERTy,finalVERTx+tamHOR,finalVERTy);
        line(finalHORx,inicioy,finalVERTx+tamHOR,finalVERTy);
        fase=22;
      }
    }
  }
  if(fase == 22){
    noStroke();
    fill(255);
    rect(12,115,315,28);
    image(avancar,750,600,150,36); // botao avancar
    // calcura e imprime a distancia a reta certa
    distaopontocerto3=sqrt(pow((finalVERTx+tamHOR - linex),2) + pow((finalVERTy - finalVERTy),2));
    println(int(distaopontocerto3));
    fill(68,57,117);
    text((int)distaopontocerto3,780,120);
    if(mouseX>750&&mouseY>600){ //Acende o botao caso o mouse passe ali
      image(avancarativado,750,600,150,36);
      if(mousePressed){
        fase=23;
        delay(100);
      }
    }
    else{
      image(avancar,750,600,150,36);
    }
  }
  if(fase == 23){ // fase do espelhamento
    fill(255);
    noStroke();
    rect(0,menuy+1,menux,500); // apaga a tela de jogo
    image(titulo4,12,115,314,27);
    stroke(0);
    line(retasinx,retasiny,retaumfinx,retasfiny);
    stroke(0,150,150);
    line(retaumfinx-20,retasiny,retasinx+(retasinx-retaumfinx),retasiny);
    if (mouseY>menuy&&mouseY<600){
      stroke(0);
      line(retasinx,retasiny,mouseX,mouseY);
      if (mousePressed){
        stroke(68,57,117);
        int tenta90x=mouseX; //armazena o valor de mouseX
        int tenta90y=mouseY;
        line(retasinx,retasiny,retaumfinx,retasfiny-retasiny);
        dateespelhado3=sqrt(pow((tenta90x - retaumfinx),2) + pow((tenta90y - (retasfiny-retasiny)),2));
        println(int(dateespelhado3));
        fase=24;
      } 
    }
  }
  if(fase == 24){
    noStroke();
    fill(255);
    rect(12,115,315,28);
    image(avancar,750,600,150,36);
    fill(68,57,117);
    text((int)dateespelhado3,780,138);
    if(mouseX>750&&mouseY>600){ //Acende o botao caso o mouse passe ali
      image(avancarativado,750,600,150,36);
      if(mousePressed){
        fase=25;
        delay(100);
      }
    }
    else{
      image(avancar,750,600,150,36);
    }
  }
  if(fase == 25){
    image(telafinal,0,0,900,642);
    // calcula media de pontos
    float mediapontos=(dateespelhado+dateespelhado2+dateespelhado3+dellipsecursor+dellipsecursor2+dellipsecursor3+dretacertaretax+dretacertaretax2+dretacertaretax3+distaopontocerto+distaopontocerto2+distaopontocerto3)/12;
    textFont(centurygothic,48);
    fill(68,57,117);
    text((int)mediapontos,355,293);
    if(mouseX<118&&mouseY>588){
      image(voltar,0,588,118,42);
      if(mousePressed){
        fase=0; 
      }
    } 
  }

}





